/* $Id: mbx_imp.h,v 1.6 2000/07/30 15:12:06 hurtta Exp $ */

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.6 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@ozone.FMI.FI>
 *****************************************************************************/

#ifdef REMOTE_MBX
struct imap_uid_ref {
    int last_mbx_index;        /* Not necessary valid -- just chache */
    int uid_number;
};

#endif

struct read_folder_state {
    long    fbytes;
    int     linecounter;
    long    fbytes_body;
    enum prepare_mode mode;

    union {
	struct FILE_rs {
	    char    * next_line;
	    int     next_line_len;
	} file;
#ifdef REMOTE_MBX
	struct POP_MBX_rs {
	    int msg_num;              /* Current msg_num */
	    int data_idx;
	    char **uidl_vector;
	    int uidl_count;
	} pop_mbx;
	struct IMAP_MBX_rs {
	    struct imap_uid_ref  current_message;
	    int                  data_idx;
	} imap_mbx;
#endif
    } a;
};

typedef void mbx_close_folder P_((struct folder_info *folder,
				  enum close_mode mode));
typedef int  mbx_lock_folder  P_((int direction,struct folder_info *folder));
typedef int  mbx_unlock_folder P_((int interrupt, struct folder_info *folder));
typedef void mbx_flush_folder P_((struct folder_info *folder));
typedef void mbx_init_folder P_((struct folder_info *folder));
typedef void mbx_free_folder P_((struct folder_info *folder));
typedef int mbx_sessionlock_folder P_((struct folder_info *folder,
				       enum sessionlock_mode mode));
typedef int mbx_ferror_folder P_((struct folder_info *folder, int clean));
typedef int mbx_prepare_read_folder P_((struct folder_info *folder,
					enum prepare_mode mode,
					READ_STATE read_state_ptr));
typedef int mbx_end_read_folder P_((struct folder_info *folder,
				    READ_STATE read_state_ptr,
				    int silent));
typedef int mbx_copy_envelope_folder P_((struct folder_info *folder,
					 READ_STATE read_state_ptr,
					 struct header_rec *entry));
typedef CONST char * mbx_is_forwarded_folder P_((struct folder_info *folder,
						 READ_STATE read_state_ptr));
typedef int mbx_copy_header_folder P_((struct folder_info *folder,
				       READ_STATE read_state_ptr,
				       char **buffer, int *len));
typedef int mbx_copy_body_folder P_((struct folder_info *folder,
				     READ_STATE read_state_ptr,
				     char **buffer, int *len,
				     long *content_remaining));
typedef int mbx_copy_envelope_end_folder P_((struct folder_info *folder,
					     READ_STATE read_state_ptr));
typedef int mbx_copy_envelope_reset_body P_((struct folder_info *folder,
					     READ_STATE read_state_ptr));
typedef FILE * mbx_folder_to_fd P_((struct folder_info *folder,long offset));
typedef int mbx_new_mail_on_folder P_((struct folder_info *folder,int *bytes));
typedef int mbx_consider_remove_folder P_((struct folder_info *folder));
typedef int mbx_prepare_keep_folder P_((struct folder_info *folder,
					KEEP_STATE keep_state_ptr));
typedef int mbx_end_keep_folder P_((struct folder_info *folder,
				    KEEP_STATE keep_state_ptr));
typedef void mbx_mark_keep_folder P_((struct folder_info *folder,
				      KEEP_STATE keep_state_ptr,
				      struct header_rec *entry,
				      int keep));
typedef CONST char * mbx_folder_type P_((struct folder_info *folder));
typedef int mbx_start_edit_folder P_((struct folder_info *folder, 
				      CONST char **buffer));
typedef int mbx_end_edit_folder P_((struct folder_info *folder));
typedef void mbx_zero_rs_fields_folder P_((struct read_folder_state *rs));
typedef void mbx_free_rs_fields_folder P_((struct read_folder_state *rs));
typedef void mbx_zero_ks_fields_folder P_((struct keep_folder_state *rs));
typedef void mbx_free_ks_fields_folder P_((struct keep_folder_state *rs));
typedef int mbx_get_folder_mode P_((struct folder_info *folder));


struct folder_type {
    mbx_close_folder             * close_it;
    mbx_lock_folder              * lock_it;
    mbx_init_folder              * init_it;
    mbx_sessionlock_folder       * sessionlock_it;
    mbx_unlock_folder            * unlock_it;
    mbx_flush_folder             * flush_it;
    mbx_ferror_folder            * ferror_it;
    mbx_prepare_read_folder      * prepare_read_it;
    mbx_end_read_folder          * end_read_it;
    mbx_copy_envelope_folder     * copy_envelope_it;
    mbx_is_forwarded_folder      * is_forwarded_it;
    mbx_copy_header_folder       * copy_header_it;
    mbx_copy_body_folder         * copy_body_it;
    mbx_copy_envelope_end_folder * copy_envelope_end_it;
    mbx_copy_envelope_reset_body * copy_envelope_reset_it;
    mbx_folder_to_fd             * xxx_to_fd;
    mbx_new_mail_on_folder       * new_mail_on_it;
    mbx_consider_remove_folder   * consider_remove_it;
    mbx_prepare_keep_folder      * prepare_keep_it;
    mbx_end_keep_folder          * end_keep_it;
    mbx_mark_keep_folder         * mark_keep_it;
    mbx_folder_type              * type;
    mbx_start_edit_folder        * start_edit_it;
    mbx_end_edit_folder          * end_edit_it;
    mbx_free_folder              * free_it;
    mbx_zero_rs_fields_folder    * zero_rs_fields_it;
    mbx_free_rs_fields_folder    * free_rs_fields_it;
    mbx_zero_ks_fields_folder    * zero_ks_fields_it;  
    mbx_free_ks_fields_folder    * free_ks_fields_it;
    mbx_get_folder_mode          * get_it_mode;
};

extern int mbx_copy_line_to_temp P_((struct folder_info *folder,
				     char *buffer, int len));
extern void append_buffer P_((char **buffer, int *len,
			      char *buffer1, int len1));
extern void mbx_flush_temp P_((struct folder_info *folder));

struct keep_folder_state {
    union {
	struct FILE_ks {
	    char * temp_keep_file;
	    FILE * keep_file;
	} file;
    } a;
};

int remote_folder_type P_((struct folder_info *fh));

#ifdef REMOTE_MBX
extern struct folder_type pop_mbx;
extern struct folder_type imap_mbx;

#ifdef I_NETINET_IN
#include <netinet/in.h>
#include <arpa/inet.h>
#endif

typedef union socket_addr
{
    struct sockaddr         sa;     /* general version */
#ifdef I_NETINET_IN
    struct sockaddr_in      sin;    /* INET family */
#endif
} SOCKADDR;

typedef enum { PORT_end = 0, PORT_pop3 = 110, PORT_imap4 = 143 } PORTS;

typedef enum { POP_error = 0,
	       POP_idle, POP_simple_command, POP_simple_response,
	       POP_multiline_command, POP_multiline_response, 
	       POP_multiline_data,
	       POP_command_ready, 
	       POP_not_logged } pop_states;

struct remote_account {
    SOCKADDR  hostaddr;
    int        socket;

    char    * username;
    char    * host;
};

extern void zero_remote_account P_((struct remote_account *ra));
extern void free_remote_account P_((struct remote_account *ra));

struct Read_Buffer {
    char      *read_buffer;
    int       read_len;
};

extern int ReadFromSocket P_((int fd, struct Read_Buffer *buffer,
			      int wanted));
extern int find_crlf P_((struct Read_Buffer *buffer, int add_null));
extern void cut_line P_((struct Read_Buffer *buffer, int len));
extern void zero_Read_Buffer P_((struct Read_Buffer *buffer));
extern void free_Read_Buffer P_((struct Read_Buffer *buffer));

struct imap_token {
    enum token_type { imap_atom, imap_number, 
		      imap_continue, imap_notag,
		      imap_status_keyword,
		      imap_other_keyword,
		      imap_list_begin, imap_list_end,
		      imap_code_begin,  imap_code_end,
		      imap_string, imap_literal ,
		      imap_zero
    }          imap_token;
    long       len_or_value;
    char     * str;
};

typedef enum { IMAP_error = 0,
	       IMAP_idle,
	       IMAP_command,
	       IMAP_command_ready_OK,
	       IMAP_command_ready_NO,
	       IMAP_command_ready_BAD,
	       IMAP_closing,
	       IMAP_not_logged
} imap_states;

struct imap_reference {
    long uid_number;       /* used correlate with Elm mailbox structure */
    long imap_flags;       /* imap \Flag bits                           */

    int    rfc822_size;
    char * internaldate;

    int     header_len;
    char  * header;

    int     body_len;
    char  * body;
};

struct Imap_Token_Buffer {
    struct imap_token * tokens;
    int                 token_count;
};

extern CONST folder_type_p POP_MBX ;
extern CONST folder_type_p IMAP_MBX ;

#define IMAP_writable     1
#define IMAP_flusherr     2
#define IMAP_folder_open  4

#endif
extern CONST folder_type_p NO_NAME;

struct private_data {
    FILE *fh_temp;		   /* current folder 	     */
    FILE *fh_folder;               /* current folder 	     */

    union {
	struct SPOOL {
	    int  lock_state;
#ifdef	USE_DOTLOCK_LOCKING
	    char *lockfile;
#endif  /* USE_DOTLOCK_LOCKING */
	} spool;
#ifdef REMOTE_MBX
	struct POP_MBX {
	    struct remote_account  C;

	    struct Read_Buffer read_buffer;

	    pop_states pop_state;

	    char      *write_buffer;
	    int       write_len;

	    /* Last command */
	    char      command[4];

	    /* parsed response */
	    char      *command_status;
	    char      *command_data;
	    int       data_len;

	    /* size from STAT */
	    int       stat_size;
	    int       stat_count;

	    struct uidl_entry  * uidl_root; /* Binary tree -- not balanced! */
	} pop_mbx;

	struct IMAP_MBX {
	    struct remote_account  C;
	    char      * folder;       /* IMAP folder, for example INBOX */
	    int       folder_status;
	    long      capability_bits;
	    long      flag_bits;

	    int       num_recent;
	    
	    struct imap_reference  *references;   /* references[0] not used */
	    int                     reference_count; /* actual number of
							messages +1 */

	    int last_uid_number;    /* uid of last message parsed */
	    

	    struct Read_Buffer read_buffer;
	    int                wanna_literal;
	    long               literal_len;

	    struct Imap_Token_Buffer read_tokens;

	    enum token_state { state_tag, state_response, 
			       state_text, state_text_code,
			       state_list } tokenizer_state;

	    char  *      current_tag ;  /* TAG of command waiting response */
	    imap_states  imap_state;
	    char  *      command_result_code;

	    struct Imap_Token_Buffer write_tokens;
	    int                 token_index; /* -1 == tag, -2 == NOOP_tag */

	    char               * write_buffer;
	    int                  write_len;
	    enum  { no_literal,
		    waiting_literal_continue,
		    continue_literal } literal_mode;

	    char  *      current_NOOP_tag ;   /* TAG for NOOP command .... */

	} imap_mbx;

#endif /* REMOTE_MBX */
    } a;
};



struct mbx_hdr_info {
    struct info_type * type_code;
    union {
	int dummy;
#ifdef REMOTE_MBX
	struct POP_MBX_if {
	    int msg_num;
	    char * uidl;   
	} pop_mbx;
	struct imap_uid_ref imap_mbx;
#endif
    } a;
};

typedef void info_zero_routine P_((struct mbx_hdr_info *info));
typedef void info_free_routine P_((struct mbx_hdr_info *info));

typedef struct info_type {
    info_zero_routine    * zero_it;
    info_free_routine    * free_it;
}  * info_type_t;

void change_rec_mbx_info P_((struct header_rec *entry,
			     info_type_t t));


/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 * End:
 */




