case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
	echo "Using config.sh from above..."
    fi
    . ./config.sh
    ;;
esac
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac

if $test "$linepr" = none -o "$linepr" = "" ; then
	default_printout=none
else
	default_printout="$cat %s | $linepr"
fi

echo "Extracting hdrs/sysdefs.h (with variable substitutions)"
sed <<!GROK!THIS! >sysdefs.h -e 's!^#undef!/\*#undef!'
/* $Id: sysdefs.SH,v 1.10 2000/07/30 15:12:07 hurtta Exp $ */
/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.10 $   $State: Exp $
 *
 *  Modified by: Kari Hurtta <hurtta+elm@ozone.FMI.FI>
 ******************************************************************************
 *  The Elm Mail System 
 *
 * 			Copyright (c) 1988-1992 USENET Community Trust
 * 			Copyright (c) 1986,1987 Dave Taylor
 *****************************************************************************/

/**  System level, configurable, defines for the ELM mail system.  **/

#define MAX_IN_WEEDLIST 150	/* max headers to weed out               */

#define MAX_HOPS	35	/* max hops in return addr to E)veryone  */

#define DEFAULT_BATCH_SUBJECT  "$defbatsub"

#define DEFAULT_DOMAIN  "$mydomain"  /* if mydomain file is missing */

/** If you want to implement 'site hiding' in the mail, then you'll need to
    uncomment the following lines and set them to reasonable values.  See 
    the configuration guide for more details....(actually these are undoc-
    umented because they're fairly dangerous to use.  Just ignore 'em and
    perhaps one day you'll find out what they do, ok?)
**/

/****************************************************************************

#define   SITE_HIDING
#define   HIDDEN_SITE_NAME	"fake-machine-name"
#define   HIDDEN_SITE_USERS	"/usr/mail/lists/hidden_site_users"

****************************************************************************/

#define SYSTEM_TEXT_FILE        "$lib/aliases.text"
#define SYSTEM_DATA_FILE        "$lib/aliases"
#define SYSTEM_RC_FILE		"$lib/elm.rc"
#define SYSTEM_MIME_TYPES	"$lib/elm.mimetypes"
#define SYSTEM_MIME_CHARSETS    "$lib/elm.mimecharsets"
#define SYSTEM_TERMINAL_INFO    "$lib/elm.terminalinfo"
#define LIBHOME                 "$lib"

#define USER_ALIAS_TEXT		".elm/aliases.text"
#define USER_ALIAS_DATA		".elm/aliases"
#define USER_MIME_TYPES	        ".elm/mime.types"
#define USER_MIME_CHARSETS	".elm/mime.charsets"
#define USER_TERMINAL_INFO	".elm/terminal.info"

#define HOSTDOMFILE             "$lib/domain"

/** where to put the output of the elm -d command... (in home dir) **/

#define	default_temp   	"$tmpdir/"
#define temp_file	"snd."
#define temp_form_file	"form."
#define temp_mbox	"mbox."
#define temp_print      "print."
#define temp_edit	"elm-edit"
/* #define temp_uuname	"uuname." */
#define temp_state	"est."

#define emacs_editor	"$emacs"
#define vi_editor	"$vi"

#define default_editor	"$defeditor $editoropts"
#define mailhome	"$maildir/"

#define default_pager	"$pager"
#define DEFAULT_PRINTOUT	"$default_printout"

#define DEFAULT_SYSTEM_CHARSET	"$defsystemcharset"
#define execmail	"$execmail"

#define sendmail	"$sendmail"
#define submitmail	"$submit"
#define submitflags	"-mlrnvxto,cc*"
#define mailer		"$mailer"

#define mailx		"$mailx"

#define helphome	"$lib"
#define helpfile	"elm-help"

#define ELMRC_INFO	"$lib/elmrc-info"

#define ELMRCFILE	".elm/elmrc"
#define old_elmrcfile	".elm/elmrc.old"
#define MAILHEADERS	".elm/elmheaders"
#define dead_letter	"Canceled.mail"

#define unedited_mail	"emergency.mbox"

#define newalias	"newalias 1>&2 > /dev/null"
#define readmsg		"readmsg"

#define remove_cmd	"$rm -f"	/* how to remove a file */

#define MSG_SEPARATOR	"\001\001\001\001\n"	/* mmdf message seperator */

#ifdef CRAY
/* avoid conflict with typedef'd word */
#define word wrd   
#endif /* CRAY */

#ifndef STRSTR
char *strstr();
#endif

!GROK!THIS!
