static char rcsid[] = "@(#)$Id: panic.c,v 1.3 2000/06/14 15:40:28 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.3 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@ozone.FMI.FI>
 *****************************************************************************/

#include "headers.h"
#include "s_me.h"

static void def_panic_prepare P_((CONST int interrupt, 
				  CONST char * title,
				  CONST char * ms));

static void def_panic_prepare(interrupt,title,ms)
     CONST int interrupt;
     CONST char * title;
     CONST char * ms;
{
    /* NULL */
}

static panic_prepare *prepare = &def_panic_prepare;
void set_panic_prepare(fn)
     panic_prepare *fn;
{
    prepare = fn;
}

static void def_panic_exit P_((CONST int interrupt));
static void def_panic_exit(interrupt)
     CONST int interrupt;
{
    if (interrupt)
	abort();
    exit(127);
}

static panic_exit *exit_rut = &def_panic_exit;
void set_panic_exit(fn)
     panic_exit *fn;
{
    exit_rut = fn;
}

void panic(title,f,ln,pr,ms,interrupt) 
     CONST char * title;     
     CONST char * f;
     CONST int ln;
     CONST char * pr;
     CONST char * ms;
     CONST int interrupt;
{

    static VOLATILE int in_panic  = 0;

    dprint(1,(debugfile,"\n%s in %s:%d:%s\n",title,f,ln,pr));
    dprint(1,(debugfile,">>%s\n",ms));
    
    
    dprint(1,(debugfile,"** in_panic = %d\n",in_panic));

    switch (in_panic) {

    case 0: in_panic++;
	prepare(interrupt,title,ms);

    case 1: in_panic++;	
	fprintf(stderr,"\n%s in %s:%d:%s\n",title,f,ln,pr);
	fprintf(stderr,">>%s\n",ms);

    case 2: in_panic++;	
#if DEBUG
	if (debug > 10) {
	    fprintf(stderr,"ABORTING...\n");
	    fflush(stderr);
	    abort();
	}
#endif
	exit_rut(interrupt);
    case 3: in_panic++;	
	fprintf(stderr,"ABORTING...\n");
	fflush(stderr);
	abort();
    default:
	abort();
    }
}

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 * End:
 */

