static char rcsid[] = "@(#)$Id: unicode.c,v 1.3 2000/07/30 15:12:12 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.3 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@ozone.FMI.FI>
 *****************************************************************************/

#include "headers.h"
#include "s_me.h"
#include "cs_imp.h"


/* NOTE:

              UOP_printable   returns 0 if caharacter is not known to be
                              printable

              UOP_noctrl      returns 0 if character is known to be
                              control character
*/

/* Returns 0 if char not OK, otherwise char or converted char */
uint16 unicode_ch(ch,op)
     unsigned int ch; 
     enum unicode_op op; 
{
    
    switch(op) {
    case UOP_none: 
	break;
    case UOP_lowercase:
	if (ch >= 0x0041 && ch <= 0x005A)               /* ASCII range  */
	    ch = ( ch - 0x0041) + 0x0061;
	else if (ch >= 0x00C0 && ch <= 0x00D6)          /* LATIN1 range */
	    ch = ( ch - 0x00C0) + 0x00E0;
	else if (ch >= 0x00D8 && ch <= 0x00DE)          /* LATIN1 range */
	    ch = ( ch - 0x00D8) + 0x00F8;
	break;
    case UOP_noctrl: 
	if (ch <= 0x001F)                              /* ASCII ctrl range */
	    ch = 0;
	else if (ch >= 0x007F && ch <= 0x009F)
	    ch = 0;
	break;
    case UOP_printable:
	if (ch >= 0x0020 && ch <= 0x007E)              /* ASCII range */
	    break;
	else if (ch >= 0x00A0 && 0x00FF)               /* Latin1 range */
	    break;
	else
	    ch = 0;                          /* Not known if printable */
	break;
    }

    return ch;
}



/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 * End:
 */
