static char rcsid[] = "@(#)$Id: id_phrase.c,v 1.3 2000/07/30 15:12:20 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.3 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@ozone.FMI.FI>
 *****************************************************************************/

#include "headers.h"
#include "me.h"

void zero_id_phrase(P)
     struct id_phrase *P;
{
    P->id   = NULL;
    P->text = NULL;
}

void free_id_phrase(P)
     struct id_phrase *P;
{
    if (P->id)
	free(P->id);
    P->id = NULL;
    if (P->text)
	free_string(&(P->text));    
}

int check_8bit_id_phrase(P)
     struct id_phrase *P;
{
    if (P->id && check_8bit_str(P->id))
	return TRUE;
    if (P->text && !can_ascii_string(P->text))
	return TRUE;
    return FALSE;
}

int check_8bit_string(P)
     struct string *P;
{
    if (!P)
	return FALSE;
    if (!can_ascii_string(P))
	return TRUE;
    return FALSE;
}

void write_id_phrase_header (f,hdr_name,P, top_encoding, enmime, hdr_charset)
     FILE *f;
     char *hdr_name; 
     struct id_phrase * P;
     int top_encoding;
     int enmime;
     charset_t hdr_charset;
{
    long POS = ftell(f);

#define LEN (ftell(f)-POS)
#define WRAP print_EOLN(f,top_encoding), (POS = ftell(f)), fputc(' ',f)

    char *c;
    int X = 0;

    if (!P -> id  && !P -> text) {
	dprint(16,(debugfile,"write_id_phrase_header: (%s) -- NONE\n",
		   hdr_name));
	return;
    }

    fputs(hdr_name,f);
    fputs(": ",f);

    dprint(16,(debugfile,"write_id_phrase_header: (enmime=%d) %s: \n",
	       enmime,hdr_name));


    if (P->id) {
	fputs(P->id,f);
	dprint(15,(debugfile,"%s",P->id));
    }

    if (string_len(P->text) &&
	0x0020 == give_unicode_from_string(P->text,0)) {
	
	if ((LEN > 60)) {
	    WRAP;
	    dprint(15,(debugfile,"[WRAP]\n          "));
	} else {
	    fputc(' ',f);
	    dprint(15,(debugfile," "));
	}
	X = 1;
    }

    dprint(15,(debugfile,"write_id_phrase_header: %s:",hdr_name));

    while (string_len(P->text) > X) {
	int x = X;
	struct string * temp = clip_from_string(P->text,&X,900);
	char * s = string_to_hdr(HDR_PHRASE,temp,
				 hdr_charset,enmime);
	dprint(15,(debugfile,"{phrase quoted=%s}\n",s));
	dprint(15,(debugfile,"\n          [%d..%d] ",x,X));
	
	for (c = s; *c != '\0'; c++) {
	    if (*c == '\n' || 
		(whitespace(*c) && (LEN > 75))) {
		WRAP;
		dprint(15,(debugfile,"[WRAP]\n          "));
	    } else {
		fputc(*c,f);
		dprint(15,(debugfile,"%c",*c));
	    }
	}

	free(s);
	free_string(&temp);
    }
    print_EOLN(f,top_encoding);    
    dprint(15,(debugfile,"[EOLN]\n"));
}

void write_string_header (f,hdr_name,P, top_encoding, enmime, hdr_charset)
     FILE *f;
     char *hdr_name; 
     struct string * P;
     int top_encoding;
     int enmime;
     charset_t hdr_charset;
{
    long POS = ftell(f);

#define LEN (ftell(f)-POS)
#define WRAP print_EOLN(f,top_encoding), (POS = ftell(f)), fputc(' ',f)

    char *c;
    int X = 0;

    fputs(hdr_name,f);
    fputs(": ",f);

    dprint(16,(debugfile,"write_string_header: (enmime=%d) %s: \n",
	       enmime,hdr_name));

    dprint(15,(debugfile,"write_id_phrase_header: %s:",hdr_name));

    while (string_len(P) > X) {
	int x = X;
	struct string * temp = clip_from_string(P,&X,900);
	char * s = string_to_hdr(HDR_TEXT,temp,
				 hdr_charset,enmime);
	dprint(15,(debugfile,"{text encoded=%s}\n",s));
	dprint(15,(debugfile,"\n          [%d..%d] ",x,X));
	
	for (c = s; *c != '\0'; c++) {
	    if (*c == '\n' || 
		(whitespace(*c) && (LEN > 75))) {
		WRAP;
		dprint(15,(debugfile,"[WRAP]\n          "));
	    } else {
		fputc(*c,f);
		dprint(15,(debugfile,"%c",*c));
	    }
	}
	
	free(s);
	free_string(&temp);
    }
    print_EOLN(f,top_encoding);    
    dprint(15,(debugfile,"[EOLN]\n"));
}

#undef LEN
#undef WRAP

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 * End:
 */
